----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:46:36 07/02/2015 
-- Design Name: 
-- Module Name:    delay256 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity delay256 is
    Port ( clk : in  STD_LOGIC;
           din : in  STD_LOGIC;
           delay : in  STD_LOGIC_VECTOR (7 downto 0);
           dout : out  STD_LOGIC);
end delay256;

architecture Behavioral of delay256 is
signal dl : std_logic_vector(7 downto 0) := (others => '0');

begin
i_dl0 : SRLC32E
   port map (
      Q => dl(0),        -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => delay(4 downto 0),        -- 5-bit shift depth select input
      CE => '1',      -- Clock enable input
      CLK => clk,    -- Clock input
      D => din         -- SRL data input
   );
g_dl : for i in 1 to 7 generate
	i_dl : SRLC32E
   port map (
      Q => open,        -- SRL data output
      Q31 => dl(i),    -- SRL cascade output pin
      A => "11111",        -- 5-bit shift depth select input
      CE => '1',      -- Clock enable input
      CLK => clk,    -- Clock input
      D => dl(i-1)         -- SRL data input
   );
end generate;
process(clk)
begin
	if(clk'event and clk = '1')then
		case delay(7 downto 5) is
			when "000" => dout <= dl(0);
			when "001" => dout <= dl(1);
			when "010" => dout <= dl(2);
			when "011" => dout <= dl(3);
			when "100" => dout <= dl(4);
			when "101" => dout <= dl(5);
			when "110" => dout <= dl(6);
			when others => dout <= dl(7);
		end case;
	end if;
end process;
end Behavioral;

